<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Listado de Recibos
      <q-space />
      <div class="q-gutter-xs">
        <q-btn
          flat
          dense
          icon="attach_money"
          label="Nuevo"
          to="/finanzas/recibos/nuevo"
        />
      </div>
    </q-toolbar>

    <q-card class="q-mt-sm">
      <q-table
        :dense="true"
        :rows="dataSet"
        :columns="columnas"
        row-key="uuid"
        v-model:pagination="recibosListadoStore.filtros"
        :loading="loading"
        @request="onPaginar"
      >
        <!--------------------------------------
            loading
          ---------------------------------------->
        <template v-slot:loading>
          <Loading showing />
        </template>

        <template v-slot:top-left>
          <div class="q-col-gutter-md row">
            <q-input
              dense
              placeholder="Buscar ..."
              v-model="recibosListadoStore.filtros.query"
              debounce="300"
            >
              <template v-slot:append>
                <q-icon name="search" />
              </template>
            </q-input>

            <q-btn color="green" flat label="Filtrar" @click="onRequest" />
            <q-btn color="blue" flat label="Reset" @click="onResetFiltros" />
          </div>
        </template>
        <template v-slot:body-cell-numero="props">
          <q-td :props="props">
            {{ props.row.numero }}
            <q-chip
              v-if="props.row.eliminado"
              dense
              square
              color="red"
              text-color="white"
            >
              Recibo Anulado
            </q-chip>
          </q-td>
        </template>

        <template v-slot:body-cell-opciones="props">
          <q-td :props="props">
            <q-btn
              flat
              color="green"
              size="sm"
              icon="point_of_sale"
              :to="'/finanzas/recibos/detalle/' + props.row.uuid"
            >
              Detalle
            </q-btn>
            <q-btn
              flat
              color="green"
              size="sm"
              icon="picture_as_pdf"
              :to="'/finanzas/recibos/detalle/' + props.row.uuid"
            >
              PDF
            </q-btn>
          </q-td>
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, onMounted, ref } from 'vue';
import { QTableProps } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import { useRecibosListadoStore } from 'src/stores/finanzas/recibosListadoStore';
import Loading from 'src/components/Loading.vue';
// Defino las columnas de la tabla
const columnas: QTableProps['columns'] = [
  { name: 'numero', label: 'Numero', field: 'numero', align: 'left' },
  { name: 'fecha', label: 'Fecha', field: 'fecha', align: 'left' },
  {
    name: 'monto',
    label: 'Monto',
    field: 'monto',
    align: 'right',
  },
  { name: 'evento', label: 'Evento', field: 'evento', align: 'left' },

  { name: 'detalle', label: 'Detalle', field: 'detalle', align: 'left' },
  { name: 'opciones', label: 'Opciones', field: 'opciones', align: 'left' },
];

export default defineComponent({
  components: { Loading },
  name: 'ListadoRecibosPage',
  setup() {
    const loading = ref(true);
    const recibosListadoStore = useRecibosListadoStore();

    onMounted(() => {
      onRequest();
    });

    ////////////////////////////////////////////////////////////////////////////////
    //            GESTION DE PAGINADO Y GESTION DE DATOS
    ////////////////////////////////////////////////////////////////////////////////
    /*********************************************
     *  Metodo onPaginar
     *  Gestiona la configuracion del paginado.
     */
    function onPaginar(props: QTableProps) {
      recibosListadoStore.setPaginar(props);
      onRequest();
    }

    function onFiltrar() {
      recibosListadoStore.filtroActivado = true;
      recibosListadoStore.filtros.page = 1; // siempre que vuelvo a filtra, vuelvo a la pagina 1.
      onRequest();
    }

    /*********************************************
     *  Metoto onRequest
     *  encargado de obtener los datos desde la API
     */
    const dataSet = ref([]);
    function onRequest() {
      loading.value = true;
      api
        .get('/api/finanzas/recibos', {
          params: recibosListadoStore.parametros,
        })
        .then((response: AxiosResponse) => {
          recibosListadoStore.setRowTotal(response.data.count); // Actializo la cantidas de row, por si cambio
          dataSet.value = response.data.data;
          loading.value = false;
        })
        .catch(() => {
          loading.value = false;
        });
    }

    /*********************************************
     *  Metoto resetFiltros
     *  Reinilizo los Filtros
     */
    function onResetFiltros() {
      recibosListadoStore.resetFiltros();
      // getCombosEquipos();
      // Recargo la info de la pagina !
      onRequest();
    }

    return {
      columnas,
      dataSet,
      recibosListadoStore,
      onRequest,
      onPaginar,
      onResetFiltros,
      onFiltrar,
      loading,
    };
  },
});
</script>
